#include "thread.h"

void *
___poller_thread_start(void *args__)
{
    struct ___poller_thread_args *args         = (struct ___poller_thread_args *)args__;
    void *(*start)(struct poller_thread_arg *) = args->start;
    struct poller_thread_arg *arg              = args->arg;
    free(args__);
    return start(arg);
}

UNUSED int
poller_new(struct poller_thread *th, void *(*func)(struct poller_thread_arg *), void *args)
{
    pthread_mutex_t mtx1     = PTHREAD_MUTEX_INITIALIZER;
    pthread_mutex_t mtx2     = PTHREAD_MUTEX_INITIALIZER;
    struct poller_thread th_ = {
        .input_lock  = mtx1,
        .output_lock = mtx2,
    };

    stack_new(&th_.input);
    stack_new(&th_.output);

    struct ___poller_thread_args *__args;
    *th               = th_;
    __args            = LKT_ALLOC_STRUCT(___poller_thread_args);
    __args->start     = func;
    __args->arg       = args;
    __args->arg->self = th;

    if (pthread_create(&(th->th), NULL, ___poller_thread_start, __args)) {
        LOG_ERROR("THREAD", "Failed to create a poller thread");
        return 1;
    }

    LOG_INFO("THREAD", "Create a new poller thread");
    return 0;
}

UNUSED int
poller_join(struct poller_thread *th, void **ret)
{
    int sta = pthread_join(th->th, ret);
    LOG_ERROR_IF(sta, "THREAD", "Failed to join thread");

    stack_free(&th->input);
    stack_free(&th->output);
    LOG_WARN("THREAD", "Thread joined");

    memset(th, 0, sizeof(struct poller_thread));
    return sta;
}

UNUSED int
th_append(struct stack *lst, pthread_mutex_t *lock, void *ptr)
{
    DO_WITH_LOCK(*lock, error, { stack_push(lst, ptr); });
    return 0;
error:
    return 1;
}

UNUSED int
th_pop(struct stack *lst, pthread_mutex_t *lock, void **ptr)
{
    RETURN_IF(pthread_mutex_lock(lock), "Failed to lock", 1);
    int ret = stack_pop(lst, ptr);
    RETURN_IF(pthread_mutex_unlock(lock), "Failed to lock", 1);
    return ret;
}

UNUSED int
th_head(struct stack *lst, pthread_mutex_t *lock, void **ptr)
{
    RETURN_IF(pthread_mutex_lock(lock), "Failed to lock", 1);
    int ret = stack_head(lst, ptr);
    RETURN_IF(pthread_mutex_unlock(lock), "Failed to lock", 1);
    return ret;
}
